;-*- Mode:LISP; Package:LAMBDA; Readtable:ZL; Base:8 -*-
;;;
;;; Written in 1983 by Ken Kahn and Mats Carlsson.
;;;

(SI:DEFINE-SIMPLE-TRANSFORMATION :LAMBDA-ASSEMBLE LAMBDA:MICRO-ASSEMBLE-SYSTEM-TOP-LEVEL
     LAMBDA:FILE-TEST-ALWAYS (':LISP) (':LMC)
     NIL NIL T)	;LOAD like

(SI:DEFINE-SIMPLE-TRANSFORMATION :LAMBDA-ASSEMBLE-experimental
				 LAMBDA:MICRO-ASSEMBLE-SYSTEM-TOP-LEVEL-experimental
     LAMBDA:FILE-TEST-ALWAYS (':LISP) (':LMC)
     NIL NIL T)	;LOAD like

(SI:DEFINE-MAKE-SYSTEM-SPECIAL-VARIABLE SI:*FILES-TO-MICRO-ASSEMBLE* NIL)

(DEFSYSTEM UCODE
    (:NAME "Ucode")
    (:NICKNAMES "Lambda-Ucode")
    (:PACKAGE "LAMBDA")
    (:OUTPUT-PATHNAME "SYS:UBIN;ULAMBDA")
    (:PATHNAME-DEFAULT "SYS:ULAMBDA;")
    (:USE-FAST-READER T)
    (:LAMBDA-ASSEMBLE ("UC-PARAMETERS" "UC-LAMBDA"  ;UC-LAMBDA must follow UC-PARAMETERS
		       "UC-LAMBDA-MACROCODE" "UC-CALL-RETURN" "UC-STORAGE-ALLOCATION"
		       "UC-FCTNS" "UC-LAMBDA-ARRAY" "UC-LOGICAL" 
		       "UC-ARITH" "UC-STRING" "UC-TRANSPORTER" "UC-SCAVENGER"
		       "UC-CLOSURE"
		       ;"UC-STACK-CLOSURE" ;No longer used
		       "UC-METER" "UC-HACKS" "UC-TV" "UC-TRACK-MOUSE"
		       "UC-LAMBDA-PAGE-FAULT" "UC-LAMBDA-DISK" "UC-LAMBDA-INTERRUPT" 
		       "UC-CHAOS" "UC-STACK-GROUPS" "UC-LAMBDA-COLD-DISK" "UC-MC"
;		       "UC-PROLOG"
		       "UC-INITIALIZATION"  ;flushed from physical memory after initialization.
		       )))

(DEFSYSTEM PROLOG-UCODE
    (:NAME "Prolog-Ucode")
    (:NICKNAMES "Prolog-Ucode")
    (:PACKAGE "LAMBDA")
    (:OUTPUT-PATHNAME "SYS:UBIN;ULAMBDA-PROLOG")
    (:PATHNAME-DEFAULT "SYS:ULAMBDA;")
    (:USE-FAST-READER T)
    (:LAMBDA-ASSEMBLE ("UC-PARAMETERS" "UC-LAMBDA"  ;UC-LAMBDA must follow UC-PARAMETERS
		       "UC-LAMBDA-MACROCODE" "UC-CALL-RETURN" "UC-STORAGE-ALLOCATION"
		       "UC-FCTNS" "UC-LAMBDA-ARRAY" "UC-LOGICAL" 
		       "UC-ARITH" "UC-STRING" "UC-TRANSPORTER" "UC-SCAVENGER"
		       "UC-CLOSURE" ;Mats
		       ;"UC-STACK-CLOSURE" ;No longer used
		       "UC-METER" "UC-HACKS" "UC-TV" "UC-TRACK-MOUSE"
		       "UC-LAMBDA-PAGE-FAULT" "UC-LAMBDA-DISK" "UC-LAMBDA-INTERRUPT" 
		       "UC-CHAOS" "UC-STACK-GROUPS" "UC-LAMBDA-COLD-DISK" "UC-MC"
		       "UC-PROLOG"
		       "UC-INITIALIZATION"  ;flushed from physical memory after initialization.
		       )))

